/* =====================================================================

   LiMo - PSX2 Liblary
      lmp_joypad  - ѥåϥޥ͡㡼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Jun.26.2001  ߷ס

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  lmp_pad_init        -- ѥå³ν
  lmp_pad_release     -- ѥåɽνλ꥽
  lmp_pad_stat        -- ѥå³Ϥ
  lmp_pad_poll        -- ѥåɾɤ߼(ե졼ॳ)
  lmp_pad_read        -- ѥåϾϤ
  lmp_pad_read_triger -- ѥåϾϤ(ȥꥬ)
  lmp_pad_read_repeat -- ѥåϾϤ(ʰץԡ)
  lmp_pad_act         -- 奨ưλ
  lmp_pad_act_stat    -- 奨ưĴ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <linux/ps2/pad.h>
#include "lmp_joypad.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

#define  STATDEV "/dev/ps2padstat"
#define  PADSTAT_SIZE  4

#define  LOCAL_DEBUG  1

/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  analog_pad_check(int);
void  act_control(void);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ǥХ̾ */
const char  *joyport[] = {
  "/dev/ps2pad00",
  "/dev/ps2pad10"
};

/* ----- ѥå³ */
static padstat   j_info;

/* ----- ʥꥯ */
static int  store_mode;
static int  store_button_mode;

/* ----- ѥåɾݻ */
static padread  input[PADMAX];

/* ----- 奨Υȥ */
static int act_work[PADMAX];
static int act_time[PADMAX];


/* -----------------------------------------------------------------------
 --- Interface
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  lmp_pad_init        -- ƥν

   return : 
       analog_mode = ʥƥåͭˤ뤫
       analog_b_sw = ʥܥͭˤ뤫
-------------------------------------------------------------- */
void   lmp_pad_init(int analog_mode, int analog_b_sw)
{
  unsigned char  work[PADSTAT_SIZE*PADMAX];	/* padstat μ */
  int	i, size;
  int	fd;
  int	r;
  struct ps2pad_modeinfo  padinfo;
  struct ps2pad_mode  alock;
  struct ps2pad_actinfo  actinfo;
  struct ps2pad_combinfo  combinfo;

   
  store_mode = analog_mode;
  store_button_mode = analog_b_sw;

  /* ----- STATδñʽ */
  for(i=0; i<PADMAX; i++) {
    j_info.pad[i] = 0;
    j_info.fd[i] = 0;
  }


  /* --------------------------------------------*/
  /* ----- ѥåɥǥХΥץ              */
  for(i=0; i<PADMAX; i++) {
    fd = open(joyport[i], O_RDONLY);
#if LOCAL_DEBUG
  printf("open pad %d\n", fd);
#endif
    if (fd < 0) {
      /* --- ץ󥨥顼 */
      j_info.pad[i] = 0;
      j_info.fd[i] = 0;
      continue;
    }
    else {
      j_info.fd[i] = fd;
    }
    /* ----- ѥåξܺ */
    /* --- ѥåɤҤäƤ뤫 */
    do {
      ioctl(fd, PS2PAD_IOCGETSTAT, &r);
#if LOCAL_DEBUG
  printf("pad stat %d\n", r);
#endif
    } while(r == PS2PAD_STAT_BUSY);
    if (r == PS2PAD_STAT_NOTCON) {
      j_info.pad[i] = 0;
      continue;
    }
    else {
      /* -- ѥåɤμ */
      padinfo.term = PS2PAD_MODECURID;
      ioctl(fd, PS2PAD_IOCMODEINFO, &padinfo);
#if LOCAL_DEBUG
  printf("pad info %d\n", padinfo.result);
#endif
      j_info.pad[i] = padinfo.result;
    }
    /* --- ʥƥåꤽ */
    if ((j_info.pad[i] == 0x05) ||
	(j_info.pad[i] == 0x07) || 
	(j_info.pad[i] == 0x04)) {
      if (j_info.pad[i] == 0x04) {
	/* -- ʥ⡼ɤäƤ饢ʥڤؤ */
	analog_pad_check(i);
	if (j_info.pad[i] != 0x04)
	  j_info.analog_p[i] = 1;
      }
      else {
	j_info.analog_p[i] = 1;
      }
    }
    else {
      j_info.analog_p[i] = 0;
    }
    /* --- ܥѥåɤ */
    if (j_info.pad[i] == 0x07) {
      if (analog_b_sw == 1) {
	ioctl(fd, PS2PAD_IOCPRESSMODEINFO, &r);
#if LOCAL_DEBUG
  printf("analog button %d\n", r);
#endif
	if (r == 1) {
	  j_info.analog_b[i] = 1;
	  ioctl(fd, PS2PAD_IOCENTERPRESSMODE);
	}
	else {
	  j_info.analog_b[i] = 0;
	  ioctl(fd, PS2PAD_IOCEXITPRESSMODE);
	}
      }
      else {
	j_info.analog_b[i] = 0;
	ioctl(fd, PS2PAD_IOCEXITPRESSMODE);
      }
    }
    else {
      j_info.analog_b[i] = 0;
    }
    /* --- 奨ɤ߼ */
    if (j_info.pad[i] == 0x07) {
       /* --- ȤꤢȽ̤ϤʤǤ */
       actinfo.actno = -1;
       ioctl(fd, PS2PAD_IOCACTINFO, &actinfo);
       j_info.act[i] = actinfo.result;
#if LOCAL_DEBUG
  printf("actuator num %d %d\n", i, j_info.act[i]);
#endif
#if LOCAL_DEBUG
  combinfo.listno = 0;
  combinfo.offs = 0;
  ioctl(fd, PS2PAD_IOCCOMBINFO, &combinfo);
  printf("combo dat1 : %d\n", combinfo.result);
  combinfo.listno = 0;
  combinfo.offs = 1;
  ioctl(fd, PS2PAD_IOCCOMBINFO, &combinfo);
  printf("combo dat2 : %d\n", combinfo.result);
  combinfo.listno = 0;
  combinfo.offs = 2;
  ioctl(fd, PS2PAD_IOCCOMBINFO, &combinfo);
  printf("combo dat3 : %d\n", combinfo.result);
#endif
    }
  }

}


/* -------------------------------------------------------------
  lmp_pad_release     -- ѥåɽνλ꥽

   return : 
-------------------------------------------------------------- */
void   lmp_pad_release(void)
{
  int	i;

  /* ----- ǥХΥ */
  for(i=0; i<PADMAX; i++) {
    if (j_info.fd[i] > 0) close(j_info.fd[i]);
  }

  /* ----- ¾äʤ :-) */
}


/* -------------------------------------------------------------
  lmp_pad_stat        -- ѥå³Ϥ

   return : 
-------------------------------------------------------------- */
void   lmp_pad_stat(padstat *stat)
{
   int  i;
   
   for(i=0; i<PADMAX; i++) {
      stat->fd[i] = j_info.fd[i];
      stat->pad[i] = j_info.fd[i];
      stat->analog_p[i] = j_info.analog_p[i];
      stat->analog_b[i] = j_info.analog_b[i];
      stat->err[i] = j_info.err[i];
      stat->act[i] = j_info.act[i];
   }
}


/* -------------------------------------------------------------
  lmp_pad_poll        -- ѥåɾɤ߼(ե졼ॳ)

   return : 
-------------------------------------------------------------- */
int    lmp_pad_poll(void)
{
   unsigned char padbuf[PS2PAD_DATASIZE];
   int  return_code;
   int  i, j, readsize;
   int  work;
   int  pad;

   for(i=0; i<PADMAX; i++) {
      /* ----- ѥåɤҤäƤʤä饹å */
      if (j_info.fd[i] == 0) continue;

      /* ----- Хåե˾ɤ߹ */
      readsize = read(j_info.fd[i], padbuf, PS2PAD_DATASIZE);

      /* ----- ѥåɤ̤ΤΤ˸򴹤줿 */
      work = (int)((padbuf[1] & 0xf0) >> 4);
      if (j_info.pad[i] != work) {
	 /* --- ѥåɾ */
	 /* (ǥȤäƤޤ) */
	 lmp_pad_init(store_mode, store_button_mode);
	 continue;
      }

      /* ----- ʥʬ */
      if ((j_info.pad[i] != 7) || (readsize < 9) || (store_button_mode == 0)) {
	 for(j=0; j<12; j++) {
	    input[i].button[j] = 0;
	 }
      }
      else {
	 for(j=0; j<12; j++) {
	    input[i].button[j] = padbuf[8+j];
	 }
      }
      if ((j_info.pad[i] != 7) || (readsize < 5) || (store_mode == 0)) {
	 input[i].stick_l[0] = 128;
	 input[i].stick_l[1] = 128;
	 input[i].stick_r[0] = 128;
	 input[i].stick_r[1] = 128;
      }
      else {
	 input[i].stick_l[0] = padbuf[7];
	 input[i].stick_l[1] = padbuf[6];
	 input[i].stick_r[0] = padbuf[5];
	 input[i].stick_r[1] = padbuf[4];
      }

      /* ----- ǥܥʬ */
      pad = (int)((padbuf[2]<<8) | padbuf[3]);
      pad ^= 0xffff;
      input[i].key_prev = input[i].key;
      input[i].key = pad;
      if (pad == 0) {
	 input[i].rep_cnt = 0;
      }
      else {
	 input[i].rep_cnt++;
      }

   }

   /* ----- 奨 */
   act_control();

   return(0);
}


/* -------------------------------------------------------------
  lmp_pad_read        -- ѥåϾϤ

   return : 
-------------------------------------------------------------- */
void   lmp_pad_read(int side, padread *data)
{
   int  i;

   data->key = input[side].key;
   data->key_prev = input[side].key_prev;
   data->rep_cnt = input[side].rep_cnt;
   data->stick_l[0] = input[side].stick_l[0];
   data->stick_l[1] = input[side].stick_l[1];
   data->stick_r[0] = input[side].stick_r[0];
   data->stick_r[1] = input[side].stick_r[1];
   for(i=0; i<12; i++) {
      data->button[i] = input[side].button[i];
   }
   data->gun_x = input[side].gun_x;
   data->gun_y = input[side].gun_y;
}


/* -------------------------------------------------------------
  lmp_pad_read_triger -- ѥåϾϤ(ȥꥬ)

   return : 
-------------------------------------------------------------- */
void   lmp_pad_read_triger(int side, padread *data)
{
   lmp_pad_read(side, data);
   data->key = (input[side].key ^ input[side].key_prev) & input[side].key;
}


/* -------------------------------------------------------------
  lmp_pad_read_repeat -- ѥåϾϤ(ʰץԡ)

   return : 
-------------------------------------------------------------- */
void   lmp_pad_read_repeat(int side, padread *data)
{
   if (input[side].rep_cnt < PAD_REPEAT_1) {
      lmp_pad_read_triger(side, data);
   }
   else {
      if ((input[side].rep_cnt % PAD_REPEAT_2) == 0) {
	 lmp_pad_read(side, data);
      }
      else {
	 lmp_pad_read_triger(side, data);
      }
   }
}


/* -------------------------------------------------------------
  lmp_pad_act         -- 奨ưλ

   return : ư(0=奨Բ/1=괰λ)
      side = ѥåɥ
      work = ư奨ӥåȻ
             (0=stop, 1=act a, 2=act b, 3=both)
      length = ưƤ(ե졼=pollƤФ)
-------------------------------------------------------------- */
int    lmp_pad_act(int side, int work, int length)
{
   if ((j_info.act[side] == 0) || (side >= PADMAX)) {
      return(0);
   }
   else {
      act_work[side] = work;
      act_time[side] = length;
   }
   return(1);
}

 
/* -------------------------------------------------------------
  lmp_pad_act_stat    -- 奨ưĴ

   return : ư(ưӥå)
-------------------------------------------------------------- */
int    lmp_pad_act_stat(int side)
{
   return(act_work[side]);
}




/* -----------------------------------------------------------------------
 --- ؿ
------------------------------------------------------------------------ */


/* -------------------------------------------------------------
  analog_pad_check   -- ʥ⡼ɤäƤڤؤ
   return : 
     side=Ĵ٤ѥåɤֹ
-------------------------------------------------------------- */
void  analog_pad_check(int side)
{
  struct ps2pad_modeinfo  getinfo;
  struct ps2pad_mode     setinfo;
  int	mode_num, mode[16];
  int	i, flag;

  /* -----  */
  for(i=0; i<16; i++) {
    mode[i] = 0;
  }

  /* ----- ѥåɤäƤ⡼ɤǤФ */
  getinfo.term = PS2PAD_MODETABLE;
  getinfo.offs = -1;
  ioctl(j_info.fd[side], PS2PAD_IOCMODEINFO, &getinfo);
  mode_num = getinfo.result % 16;

  for(i=0; i<mode_num; i++) {
    getinfo.term = PS2PAD_MODETABLE;
    getinfo.offs = i;
    ioctl(j_info.fd[side], PS2PAD_IOCMODEINFO, &getinfo);
    mode[i] = getinfo.result;
  }

#if  LOCAL_DEBUG
  for(i=0; i<mode_num; i++) {
    printf("pad side : %d   mode : %d\n", side, mode[i]);
  }
#endif

  /* ----- ѥåɤʥ⡼ɤäƤ뤫 */
  for(i=0; i<mode_num; i++) {
    if (mode[i] == 0x07) {
      /* --- ʥ⡼ɤڤؤ */
      setinfo.offs = i;
      setinfo.lock = 3;	/* ڤؤåϥå */
      ioctl(j_info.fd[side], PS2PAD_IOCSETMODE, &setinfo);
      j_info.pad[side] = 0x07;
#if  LOCAL_DEBUG
      printf("pad side %d set to analog.\n", side);
#endif
    }
  }

}


/* -------------------------------------------------------------
  act_control   -- 奨Υȥȥ
-------------------------------------------------------------- */
void  act_control(void)
{
   struct ps2pad_act  setactnum, setactwork;
   int  i, j, p, b;
   int  actnum;

   /* --- ưǡ򥻥åȤ */
   for(i=0; i<PADMAX; i++) {
      /* --- ѥåɤҤäƤʤä饹å */
      if (j_info.pad[i] == 0) continue;
      /* --- ѥ᡼ν */
      for(j=0; j<32; j++) {
	 setactnum.data[j] = -1;
	 setactwork.data[j] = 0;
      }
      /* --- 奨οǡ򥻥å */
      actnum = 0;
      p = j_info.act[i];
      b = 1;
      for(j=0; j<p; j++) {
	 setactnum.data[actnum] = (unsigned char)(actnum);
	 setactwork.data[actnum] = (unsigned char)((act_work[i] & b) != 0) * 1;
	 if (actnum < 32) actnum++;
	 b <<= 1;
      }
      /* --- counter decriment */
      if (act_time[i] > 0) act_time[i]--;
      else act_work[i] = 0;
      /* --- Ǥäϥʥ */
      if (setactwork.data[1] != 0) {
	setactwork.data[1] = 192;
      }
      /* --- 奨μ¹ */
      setactnum.len = 6;
      setactwork.len = 6;
      ioctl(j_info.fd[i], PS2PAD_IOCSETACTALIGN, &setactnum);
      ioctl(j_info.fd[i], PS2PAD_IOCSETACT, &setactwork);
#if LOCAL_DEBUG
printf("%d %d %d %d\n",
       setactnum.data[0], 
       setactnum.data[1], 
       setactnum.data[2], 
       setactnum.data[3]);
printf("%d %d %d %d\n",
       setactwork.data[0], 
       setactwork.data[1], 
       setactwork.data[2], 
       setactwork.data[3]);
#endif
   }
}

